#include <stdio.h>
#include <conio.h>

#define UP      0X48
#define DOWN    0X50
#define LEFT    0X4B
#define RIGHT   0X4D

#define OFF_SET(x, y)     (((x)*2) + ((y)*160))
#define VRAM_ASCII(x, y)  *(Video_address+OFF_SET(x, y))
#define VRAM_ATTR(x, y)   *(Video_address+(x)*2+1+(y)*160)

typedef struct MENU_FRAME {
  char *item;
  int x, y;
} MENU;

char far *Video_address = (char far *)0xB8000000L;

void vcharxy(int x, int y, char ch, int attr);
void vputs(char *str, int x, int y, int attr);
void display_menu();

MENU menu[4] = {
	{" New Game   Alt-N ", 0, 3},
	{" Load Game  Alt-L ", 0, 4},
	{" Options    Alt-O ", 0, 5},
	{" Quit       Alt-X ", 0, 6},
};
int main()
{
  int sno = 0;
  char ch, quit=0;
  display_menu();
  while (1)
  {
	if ((ch=getch())==0)
	{
	  switch (getch())
	  {
		case UP:
		  vputs(menu[sno].item, menu[sno].x, menu[sno].y, 7);
		  sno--;
		  if (sno < 0) sno = 3;
		  vputs(menu[sno].item, menu[sno].x, menu[sno].y, 0x70);
		  break;
		case DOWN:
		  vputs(menu[sno].item, menu[sno].x, menu[sno].y, 7);
		  sno++;
		  if (sno > 3) sno = 0;
		  vputs(menu[sno].item, menu[sno].x, menu[sno].y, 0x70);
		  break;
	  }
	} else if (ch=='\r') {
	  switch (sno)      {
		case 0: vputs("The first menu is selected... ", 0, 10, 7); break;
		case 1: vputs("The second menu is selected... ", 0, 10, 7); break;
		case 2: vputs("The third menu is selected... ", 0, 10, 7); break;
		case 3: vputs("Thank you for using.......Bye ! ", 0, 10, 7);
		  quit=1;
		  break;
	  }
	}
	if (quit) break;
  }
  return 0;
}

void vcharxy(int x, int y, char ch, int attr)
{
	VRAM_ASCII(x, y) = ch;
	VRAM_ATTR(x, y) = attr;
}

void vputs(char *str, int x, int y, int attr)
{
  while (*str != 0)
	vcharxy(x++, y, *str++, attr);
}

void display_menu()
{
  clrscr();
  vputs("------------------", 0, 0, 7);
  vputs("   MENU SYSTEM    ", 0, 1, 7);
  vputs("------------------", 0, 2, 7);
  vputs(menu[0].item, menu[0].x, menu[0].y, 0x70);
  vputs(menu[1].item, menu[1].x, menu[1].y, 0x07);
  vputs(menu[2].item, menu[2].x, menu[2].y, 0x07);
  vputs(menu[3].item, menu[3].x, menu[3].y, 0x07);
  vputs("------------------", 0, 7, 7);
}