#include <stdio.h>
#include <dos.h>
#define  BYTE_PER_SECTOR  512
int read_sector(int track, int sector, int head, int drive)
{
  #define CHAR_COUNT 16
  unsigned char ch, buffer[BYTE_PER_SECTOR];
  int i, j, cf=0;
  union REGS r;
  r.h.ah = 0x02;
  r.h.al = 1;
  r.h.ch = track;
  r.h.cl = sector;
  r.h.dh = head;
  r.h.dl = drive;
  r.x.bx = (unsigned) buffer;
  int86(0x13, &r, &r);
  for (i=0; i<BYTE_PER_SECTOR/CHAR_COUNT; i++)
  {
	for (j=0; j<CHAR_COUNT; j++)
	  printf("%02X ", buffer[i*CHAR_COUNT+j]);

	printf(" | ");

	for (j=0; j<CHAR_COUNT; j++)
	{
	  ch = buffer[i*CHAR_COUNT+j];
	  if (ch=='\t' || ch=='\r' || ch=='\n') ch = '.';
	  printf("%c", ch);
	}
	printf("\n");
  }

  printf("The number of sectors read = %d\n", r.h.al);
  printf("Disk status code = %d\n", r.h.ah);

  cf = r.x.flags & 0x0001;
  if (cf)
	printf("Disk read error!\n");

  return 1;
}
int main()
{
  int t, s, h, d;
  printf("<< Read 1 sector from a Disk >>\n");
  printf("Caution: You should try to run this program on the FAT drive.\n");
  printf("Input data for reading : track, sector, head, drvie : ");
  scanf("%d %d %d %d", &t, &s, &h, &d);
  read_sector(t, s, h, d);
  return 0;
}
