#ifndef __TEXTLIB_H__
#define __TEXTLIB_H__
/*  DEFINE Key code							     */
  #define ESC	       27
  #define BS	      0xe
  #define TAB	      0xf
  #define ENTER	       13
  #define SPACE      0x39
  #define HOME       0x47
  #define END        0x4f
  #define PGUP	     0x49
  #define PGDN	     0x51
  #define INS	     0x52
  #define DEL 	     0x53

  #define UP	     0x48
  #define DOWN	     0x50
  #define LEFT	     0x4b
  #define RIGHT      0x4d
  #define LSHIFT     0x2a
  #define RSHIFT     0x36
  #define CTRL	     0x1d
  #define ALT 	     0x38

  #define F1	     0x3b
  #define F2	     0x3c
  #define F3	     0x3d
  #define F4	     0x3e
  #define F5	     0x3f
  #define F6	     0x40
  #define F7	     0x41
  #define F8	     0x42
  #define F9	     0x43
  #define F10        0x44
  #define F11	     0x57
  #define F12	     0x58

/*  DEFINES								     */
  #define TRUE	         1
  #define FALSE	         0
  #define ASCII          0
  #define SCAN           1

  #define BOX_YES     TRUE
  #define BOX_NO     FALSE

  #define REVERSE     0x70  /* BLACK | WHITE */
  #define NORMAL      0x07  /* LIGHTGRAY(foreground) | BLACK(background) */
  #define TOP_NORMAL  0x70  /* BLACK|LIGHTGRAY<<4  */
  #define TOP_REVERSE 0x1e  /* YELLOW | BLUE  */

  #define BACGRD      	  0x30  /* CYAN */
  #define SHADE_COLOR     DARKGRAY|BLACK<<4
  #define DISABLE_COLOR   DARKGRAY|LIGHTGRAY<<4
  #define BOARD_COLOR     WHITE|BLACK<<4

  #define OFF_SET(x, y)    (x*2 + y*160)
  #define VRAM_ASCII(x, y) *(Video_address+OFF_SET(x, y))
  #define VRAM_ATTR(x, y)  *(Video_address+(x)*2+1+(y)*160)

  typedef struct menu_info {
	unsigned char far *item;
	unsigned sx, sy;
  } MENU_INFO;

/*  VARIABLES				*/
  extern char far *Video_address;

/*  FUNCTIONS PROTOTYPES	*/
  void  alert(char *msg);
  void  clsxy(int sx, int sy, int ex, int ey, char attr);
  int   confirm(char *msg);
  void  cursor_off();
  void  cursor_on(int size);
  void  errmsg(char *msg);
  int   get_vmode();
  void  goto_xy(int x, int y);
  void  make_box(int x1, int y1, int x2, int y2, int attr, int type);
  char* prompt(char *msg);
  void  set_vmode();
  void  shade_box(int sx, int sy,int ex, int ey, int xdepth, int ydepth, char attr);
  void  vcharxy(int x, int y, char ch, int attr);
  void  vclear();
  int   vprintfxy(int x, int y, int attr, unsigned char *fmt,...);
  void  vputs(int x, int y, char *text, int attr);
#endif