#include <stdio.h>
#include <errno.h>
int main(char argc, char *argv[])
{
	char ch, *p;
	FILE *fin, *fout;
	if (argc < 3) {
	  printf("Usage: bcp <srcfile> <destfile>\n");
	  exit(1);
	}
	fin = fopen(argv[1], "rb");
	if (!fin)
	{
	  perror("Unable to open source file...\n");
	  printf("errno = %d\n", errno);
	  exit(1);
	}
	fout = fopen(argv[2], "wb");
	if (!fout) {
	  perror("Unable to open destination file...\n");
	  printf("errno = %d\n", errno);
	  exit(1);
	}
	while (!feof(fin))
	{
	  ch = fgetc(fin);
	  if (ferror(fin))
	  {
		perror("Error while reading source file...\n");
		printf("errno = %d\n", errno);
		exit(1);
	  }
	  if (!feof(fin))
		fputc(ch, fout);
	  if (ferror(fout))
	  {
		perror("Error while writing destination file...\n");
		printf("errno = %d\n", errno);
		exit(1);
	  }
	}
	fclose(fin);
	fclose(fout);
	printf("1 file copied successfully...\n");
	return 0;
}
